module MUX_read_data (
	input logic reset,
	input logic read_spcr,
	input logic read_rcr,
	input logic read_xcr,
	input logic read_mcr,
	input logic read_pcr,
	input logic read_srgr,
	input logic read_xcere0,
	input logic read_xcere1,
	input logic read_xcere2,
	input logic read_xcere3,
	input logic read_rcere0,
	input logic read_rcere1,
	input logic read_rcere2,
	input logic read_rcere3,
	
	input logic [31:0] rb_out_spcr,
	input logic [31:0] rb_out_rcr,
	input logic [31:0] rb_out_xcr,
	input logic [31:0] rb_out_mcr,
	input logic [31:0] rb_out_pcr,
	input logic [31:0] rb_out_srgr,
	input logic [31:0] rb_out_xcer0,
	input logic [31:0] rb_out_xcer1,
	input logic [31:0] rb_out_xcer2,
	input logic [31:0] rb_out_xcer3,
	input logic [31:0] rb_out_rcer0,
	input logic [31:0] rb_out_rcer1,
	input logic [31:0] rb_out_rcer2,
	input logic [31:0] rb_out_rcer3,
	
	output logic [31:0] rb_read_data
);

	always_comb begin
		if(!reset) rb_read_data <= 0;
		else if(read_spcr)rb_read_data <= rb_out_spcr;
		else if(read_rcr) rb_read_data <= rb_out_rcr;
		else if(read_xcr) rb_read_data <= rb_out_xcr;
		else if(read_mcr) rb_read_data <= rb_out_mcr;
		else if(read_pcr) rb_read_data <= rb_out_pcr;
		else if(read_srgr) rb_read_data <= rb_out_srgr;
		else if(read_xcere0) rb_read_data <= rb_out_xcer0;
		else if(read_xcere1) rb_read_data <= rb_out_xcer1;
		else if(read_xcere2) rb_read_data <= rb_out_xcer2;
		else if(read_xcere3) rb_read_data <= rb_out_xcer3;
		else if(read_rcere0) rb_read_data <= rb_out_rcer0;
		else if(read_rcere1) rb_read_data <= rb_out_rcer1;
		else if(read_rcere2) rb_read_data <= rb_out_rcer2;
		else if(read_rcere3) rb_read_data <= rb_out_rcer3;
		else rb_read_data <= 0;
	end

endmodule