module PCR (
	input logic reset,
	input logic clk,
	input logic load_pcr,
	input logic [31:0] pcr,
	input logic [31:0] general_in_pcr,
	input logic load_general_pcr,
	input logic read_d_pcr,
	output logic [31:0] dynamic_reg_gp_pcr,
	output logic [31:0] rb_out_pcr
);

logic [31:0] pcr_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		pcr_value = 0;
		rb_out_pcr <= 0;
		dynamic_reg_gp_pcr <= 0;
	end
	else if (load_pcr) begin
		rb_out_pcr <= pcr;
		pcr_value = pcr;
		if(read_d_pcr) dynamic_reg_gp_pcr <= pcr_value;
		else dynamic_reg_gp_pcr <= 0;
	end
	else if (load_general_pcr) begin
		pcr_value = general_in_pcr;
		rb_out_pcr <= pcr_value;
		if(read_d_pcr) dynamic_reg_gp_pcr <= pcr_value;
		else dynamic_reg_gp_pcr <= 0;
	end
	else begin
		if(read_d_pcr) dynamic_reg_gp_pcr <= pcr_value;
		else dynamic_reg_gp_pcr <= 0;
		rb_out_pcr <= pcr_value;
	end
end

endmodule