module RCERE0 (
	input logic reset,
	input logic clk,
	input logic load_rcere0,
	input logic [31:0] rcere0,
	input logic read_d_rcere0,
	output logic [31:0] dynamic_reg_rmult_rcer0,
	output logic [31:0] dynamic_reg_tmult_rcer0,
	output logic [31:0] rb_out_rcer0
);

logic [31:0] rcere0_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		rcere0_value = 0;
		rb_out_rcer0 <= 0;
		dynamic_reg_rmult_rcer0 <= 0;
		dynamic_reg_tmult_rcer0 <= 0;
	end
	else if (load_rcere0) begin
		rb_out_rcer0 <= rcere0;
		rcere0_value = rcere0;
		if(read_d_rcere0) begin
			dynamic_reg_rmult_rcer0 <= rcere0_value;
			dynamic_reg_tmult_rcer0 <= rcere0_value;
		end
		else begin
			dynamic_reg_rmult_rcer0 <= 0;
			dynamic_reg_tmult_rcer0 <= 0;
		end
	end
	else begin
		rb_out_rcer0 <= rcere0_value;		
		if(read_d_rcere0) begin
			dynamic_reg_rmult_rcer0 <= rcere0_value;
			dynamic_reg_tmult_rcer0 <= rcere0_value;
		end
		else begin
			dynamic_reg_rmult_rcer0 <= 0;
			dynamic_reg_tmult_rcer0 <= 0;
		end
	end
end

endmodule