module RCERE1 (
	input logic reset,
	input logic clk,
	input logic load_rcere1,
	input logic [31:0] rcere1,    
    input logic read_d_rcere1,
    output logic [31:0] dynamic_reg_rmult_rcer1,
	output logic [31:0] dynamic_reg_tmult_rcer1,
	output logic [31:0] rb_out_rcer1
);

logic [31:0] rcere1_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		rcere1_value = 0;
		rb_out_rcer1 <= 0;
        dynamic_reg_rmult_rcer1 <= 0;
		dynamic_reg_tmult_rcer1 <= 0;
	end
	else if (load_rcere1) begin
		rb_out_rcer1 <= rcere1;
		rcere1_value = rcere1;
        if(read_d_rcere1) begin
			dynamic_reg_rmult_rcer1 <= rcere1_value;
			dynamic_reg_tmult_rcer1 <= rcere1_value;
		end
        else begin
			dynamic_reg_rmult_rcer1 <= 0;
			dynamic_reg_tmult_rcer1 <= 0;
		end
	end
	else begin
		rb_out_rcer1 <= rcere1_value;
        if(read_d_rcere1) begin
			dynamic_reg_rmult_rcer1 <= rcere1_value;
			dynamic_reg_tmult_rcer1 <= rcere1_value;
		end
        else begin
			dynamic_reg_rmult_rcer1 <= 0;
			dynamic_reg_tmult_rcer1 <= 0;
		end
	end
end

endmodule