module RCERE2 (
	input logic reset,
	input logic clk,
	input logic load_rcere2,
	input logic [31:0] rcere2,
    input logic read_d_rcere2,
    output logic [31:0] dynamic_reg_rmult_rcer2,
	output logic [31:0] dynamic_reg_tmult_rcer2,
	output logic [31:0] rb_out_rcer2
);

logic [31:0] rcere2_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		rcere2_value = 0;
		rb_out_rcer2 <= 0;
        dynamic_reg_rmult_rcer2 <= 0;
		dynamic_reg_tmult_rcer2 <= 0;
	end
	else if (load_rcere2) begin
		rb_out_rcer2 <= rcere2;
		rcere2_value = rcere2;
        if(read_d_rcere2) begin
			dynamic_reg_rmult_rcer2 <= rcere2_value;
			dynamic_reg_tmult_rcer2 <= rcere2_value;
		end
        else begin
			dynamic_reg_rmult_rcer2 <= 0;
			dynamic_reg_tmult_rcer2 <= 0;
		end
	end
	else begin
		rb_out_rcer2 <= rcere2_value;
        if(read_d_rcere2) begin
			dynamic_reg_rmult_rcer2 <= rcere2_value;
			dynamic_reg_tmult_rcer2 <= rcere2_value;
		end
        else begin
			dynamic_reg_rmult_rcer2 <= 0;
			dynamic_reg_tmult_rcer2 <= 0;
		end
	end
end

endmodule