module RCERE3 (
	input logic reset,
	input logic clk,
	input logic load_rcere3,
	input logic [31:0] rcere3,
    input logic read_d_rcere3,
    output logic [31:0] dynamic_reg_rmult_rcer3,
	output logic [31:0] dynamic_reg_tmult_rcer3,
	output logic [31:0] rb_out_rcer3
);

logic [31:0] rcere3_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		rcere3_value = 0;
		rb_out_rcer3 <= 0;
        dynamic_reg_rmult_rcer3 <= 0;
		dynamic_reg_tmult_rcer3 <= 0;
	end
	else if (load_rcere3) begin
		rb_out_rcer3 <= rcere3;
		rcere3_value = rcere3;
        if(read_d_rcere3) begin
			dynamic_reg_rmult_rcer3 <= rcere3_value;
			dynamic_reg_tmult_rcer3 <= rcere3_value;
		end
        else begin
			dynamic_reg_rmult_rcer3 <= 0;
			dynamic_reg_tmult_rcer3 <= 0;
		end
	end
	else begin
		rb_out_rcer3 <= rcere3_value;
        if(read_d_rcere3) begin
			dynamic_reg_rmult_rcer3 <= rcere3_value;
			dynamic_reg_tmult_rcer3 <= rcere3_value;
		end
        else begin
			dynamic_reg_rmult_rcer3 <= 0;
			dynamic_reg_tmult_rcer3 <= 0;
		end
	end
end

endmodule