module RCR (
	input logic reset,
	input logic clk,
	input logic load_rcr,
	input logic [31:0] rcr,
	output logic [31:0] rb_out_rcr
);

logic [31:0] rcr_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		rcr_value = 0;
		rb_out_rcr <= 0;
	end
	else if (load_rcr) begin
		rb_out_rcr <= rcr;
		rcr_value = rcr;
	end
	else begin
		rb_out_rcr <= rcr_value;
	end
end

endmodule