module SPCR (
	input logic reset,
	input logic clk,
	input logic load_spcr,
	input logic [31:0] spcr,
	input logic receive_in_rrdy,
	input logic receive_in_rfull,
	input logic receive_in_rsyncerr,
	input logic transmit_in_xsyncerr,
	input logic transmit_in_xempty,
	input logic transmit_in_xrdy,
	input logic load_rrdy,
	input logic load_rfull,
	input logic load_rsyncerr,	  
	input logic load_xsyncerr,
	input logic load_xempty,
	input logic load_xrdy,
	output logic [31:0] rb_out_spcr
);

logic [31:0] spcr_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		spcr_value = 0;
		rb_out_spcr <= 0;
	end
	else if (load_spcr) begin
		rb_out_spcr <= spcr;
		spcr_value = spcr;
	end
	else if (load_rrdy || load_rfull || load_rsyncerr ||
		     load_xsyncerr || load_xempty || load_xrdy) begin
		if (load_rrdy) begin
			spcr_value[1] = receive_in_rrdy; //rrdy writting
		end
		if (load_rfull) begin
			spcr_value[2] = receive_in_rfull; //rrdy writting
		end
		if (load_rsyncerr) begin
			spcr_value[3] = receive_in_rsyncerr; //rsyncerr writing
		end
		if (load_xsyncerr) begin
			spcr_value[19] = transmit_in_xsyncerr; //xsyncerr writting
		end
		if (load_xempty) begin
			spcr_value[18] = transmit_in_xempty; // xemtpy writting
		end
		if (load_xrdy) begin
			spcr_value[17] = transmit_in_xrdy; //xrdy writting
		end
		rb_out_spcr <= spcr_value;
	end
	else begin
		rb_out_spcr <= spcr_value;
	end
end

endmodule