module SRGR (
	input logic reset,
	input logic clk,
	input logic load_srgr,
	input logic [31:0] srgr,
	output logic [31:0] rb_out_srgr
);

logic [31:0] srgr_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		srgr_value = 0;
		rb_out_srgr <= 0;
	end
	else if (load_srgr) begin
		rb_out_srgr <= srgr;
		srgr_value = srgr;
	end
	else begin
		rb_out_srgr <= srgr_value;
	end
end

endmodule