module XCERE0 (
	input logic reset,
	input logic clk,
	input logic load_xcere0,
	input logic [31:0] xcere0,
	input logic read_d_xcere0,
	output logic [31:0] dynamic_reg_tmult_xcer0,
	output logic [31:0] rb_out_xcer0
);

logic [31:0] xcere0_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		xcere0_value = 0;
		rb_out_xcer0 <= 0;
		dynamic_reg_tmult_xcer0 <= 0;
	end
	else if (load_xcere0) begin
		rb_out_xcer0 <= xcere0;		
		xcere0_value = xcere0;
		if(read_d_xcere0) dynamic_reg_tmult_xcer0 <= xcere0_value;
		else dynamic_reg_tmult_xcer0 <= 0;
	end
	else begin
		rb_out_xcer0 <= xcere0_value;
		if(read_d_xcere0) dynamic_reg_tmult_xcer0 <= xcere0_value;
		else dynamic_reg_tmult_xcer0 <= 0;
	end
end

endmodule