module XCERE1 (
	input logic reset,
	input logic clk,
	input logic load_xcere1,
	input logic [31:0] xcere1,
    input logic read_d_xcere1,
    output logic [31:0] dynamic_reg_tmult_xcer1,
	output logic [31:0] rb_out_xcer1
);

logic [31:0] xcere1_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		xcere1_value = 0;
		rb_out_xcer1 <= 0;
        dynamic_reg_tmult_xcer1 <= 0;
	end
	else if (load_xcere1) begin
		rb_out_xcer1 <= xcere1;
		xcere1_value = xcere1;
        if(read_d_xcere1) dynamic_reg_tmult_xcer1 <= xcere1_value;
        else dynamic_reg_tmult_xcer1 <= 0;
	end
	else begin
		rb_out_xcer1 <= xcere1_value;
        if(read_d_xcere1) dynamic_reg_tmult_xcer1 <= xcere1_value;
        else dynamic_reg_tmult_xcer1 <= 0;
	end
end

endmodule