module XCERE2 (
	input logic reset,
	input logic clk,
	input logic load_xcere2,
	input logic [31:0] xcere2,
    input logic read_d_xcere2,
    output logic [31:0] dynamic_reg_tmult_xcer2,
	output logic [31:0] rb_out_xcer2
);

logic [31:0] xcere2_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		xcere2_value = 0;
		rb_out_xcer2 <= 0;
        dynamic_reg_tmult_xcer2 <= 0;
	end
	else if (load_xcere2) begin
		rb_out_xcer2 <= xcere2;
		xcere2_value = xcere2;
        if(read_d_xcere2) dynamic_reg_tmult_xcer2 <= xcere2_value;
        else dynamic_reg_tmult_xcer2 <= 0;
	end
	else begin
		rb_out_xcer2 <= xcere2_value;
        if(read_d_xcere2) dynamic_reg_tmult_xcer2 <= xcere2_value;
        else dynamic_reg_tmult_xcer2 <= 0;
	end
end

endmodule