module XCERE3 (
	input logic reset,
	input logic clk,
	input logic load_xcere3,
	input logic [31:0] xcere3,
    input logic read_d_xcere3,
    output logic [31:0] dynamic_reg_tmult_xcer3,
	output logic [31:0] rb_out_xcer3
);

logic [31:0] xcere3_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		xcere3_value = 0;
		rb_out_xcer3 <= 0;
        dynamic_reg_tmult_xcer3 <= 0;
	end
	else if (load_xcere3) begin
		rb_out_xcer3 <= xcere3;
		xcere3_value = xcere3;
        if(read_d_xcere3) dynamic_reg_tmult_xcer3 <= xcere3_value;
        else dynamic_reg_tmult_xcer3 <= 0;
	end
	else begin
		rb_out_xcer3 <= xcere3_value;
        if(read_d_xcere3) dynamic_reg_tmult_xcer3 <= xcere3_value;
        else dynamic_reg_tmult_xcer3 <= 0;
	end
end

endmodule