module XCR (
	input logic reset,
	input logic clk,
	input logic load_xcr,
	input logic [31:0] xcr,
	output logic [31:0] rb_out_xcr
);

logic [31:0] xcr_value;

always_ff @(posedge clk) begin
	if(!reset) begin
		xcr_value = 0;
		rb_out_xcr <= 0;
	end
	else if (load_xcr) begin
		rb_out_xcr <= xcr;
		xcr_value = xcr;
	end
	else begin
		rb_out_xcr <= xcr_value;
	end
end

endmodule