module transmit_multichannel(
        input reset, clk,

        input request_request,
        input ac_transmit_mult_active,

        input logic [31:0] rb_in_mcr,
        input logic [31:0] rb_in_rcer0,
        input logic [31:0] rb_in_rcer1,
        input logic [31:0] rb_in_rcer2,
        input logic [31:0] rb_in_rcer3,
        input logic [31:0] rb_in_xcer0,
        input logic [31:0] rb_in_xcer1,
        input logic [31:0] rb_in_xcer2,
        input logic [31:0] rb_in_xcer3,
 
        input logic [31:0] dynamic_rb_in_mcr,
        input logic [31:0] dynamic_rb_in_xcer0,
        input logic [31:0] dynamic_rb_in_xcer1,
        input logic [31:0] dynamic_rb_in_xcer2,
        input logic [31:0] dynamic_rb_in_xcer3,
        input logic [31:0] dynamic_rb_in_rcer0,
        input logic [31:0] dynamic_rb_in_rcer1,
        input logic [31:0] dynamic_rb_in_rcer2,
        input logic [31:0] dynamic_rb_in_rcer3,

        output logic [31:0] mult_out_unmasked_channel1,
        output logic [31:0] mult_out_unmasked_channel2,
        output logic [31:0] mult_out_unmasked_channel3,
        output logic [31:0] mult_out_unmasked_channel4,
        output logic [31:0] mult_out_enabled_channel1,
        output logic [31:0] mult_out_enabled_channel2,
        output logic [31:0] mult_out_enabled_channel3,
        output logic [31:0] mult_out_enabled_channel4,
        
        output logic mult_out_ready
       
      
        //output logic [3:0] estados
    );


    //State machine
    parameter SELECTION_MODE_AND_PARTITIONS = 0,
    
    PARTITIONS_2_MODE_0 = 1,
    PARTITIONS_2_MODE_0_WAIT = 2,
    PARTITIONS_2_MODE_1 = 3,
    //    PARTITIONS_2_MODE_1_A = 3,
    //    PARTITIONS_2_MODE_1_B = 4,
    PARTITIONS_2_MODE_1_WAIT = 5,
    
    PARTITIONS_2_MODE_2 = 6,
    PARTITIONS_2_MODE_2_WAIT = 7,
    //PARTITIONS_2_MODE_2_A = 6,
    //PARTITIONS_2_MODE_2_B = 7,
    //PARTITIONS_2_MODE_2_WAIT = 8,

    PARTITIONS_2_MODE_3 = 9,
    PARTITIONS_2_MODE_3_WAIT = 10,
    //PARTITIONS_2_MODE_3_A = 9,
    //PARTITIONS_2_MODE_3_B = 10,
    //PARTITIONS_2_MODE_3_WAIT = 11,
    
    PARTITIONS_8_MODE_0 = 12,
    PARTITIONS_8_MODE_0_WAIT = 13,
    
    PARTITIONS_8_MODE_1 = 14,
    PARTITIONS_8_MODE_1_WAIT = 15,

    PARTITIONS_8_MODE_2 = 16,
    PARTITIONS_8_MODE_2_WAIT = 17,

    PARTITIONS_8_MODE_3 = 18,
    PARTITIONS_8_MODE_3_WAIT = 19;
    
    reg[4:0] state, next;
	

    logic out_ready;
    logic [31:0] out_unmasked_channel1;
    logic [31:0] out_unmasked_channel2;
    logic [31:0] out_unmasked_channel3;
    logic [31:0] out_unmasked_channel4;
    logic [31:0] out_enabled_channel1;
    logic [31:0] out_enabled_channel2;
    logic [31:0] out_enabled_channel3;
    logic [31:0] out_enabled_channel4;
    
    logic [31:0] out_enabled_r_channel1;
    logic [31:0] out_enabled_r_channel2;
    logic [31:0] out_enabled_r_channel3;
    logic [31:0] out_enabled_r_channel4;
    
    
    logic [31:0] static_xcer0;
    logic [31:0] static_xcer1;
    logic [31:0] static_xcer2;
    logic [31:0] static_xcer3;
                   
    logic [31:0] static_rcer0;
    logic [31:0] static_rcer1;
    logic [31:0] static_rcer2;
    logic [31:0] static_rcer3;
                   
    //                   
    //    logic [31:0] static_xcer02;
    //    logic [31:0] static_xcer12;
    //    logic [31:0] static_xcer22;
    //    logic [31:0] static_xcer32;
    //
    //    logic [31:0] static_rcer02;
    //    logic [31:0] static_rcer12;
    //    logic [31:0] static_rcer22;
    //    logic [31:0] static_rcer32;
    //    
    //    logic [31:0] out_unmasked_channel12;
    //    logic [31:0] out_unmasked_channel22;
    //    logic [31:0] out_unmasked_channel32;
    //    logic [31:0] out_unmasked_channel42;
    //
    //    logic [31:0] out_enabled_channel12;
    //    logic [31:0] out_enabled_channel22;
    //    logic [31:0] out_enabled_channel32;
    //    logic [31:0] out_enabled_channel42;
    //    
    
    logic [31:0] out_unmasked_channel1n;
    logic [31:0] out_unmasked_channel2n;
    logic [31:0] out_unmasked_channel3n;
    logic [31:0] out_unmasked_channel4n;
    logic [31:0] out_enabled_channel1n;
    logic [31:0] out_enabled_channel2n;
    logic [31:0] out_enabled_channel3n;
    logic [31:0] out_enabled_channel4n;
    
    logic [31:0] old_enabled_channel1n;
    logic [31:0] old_enabled_channel2n;
    logic [31:0] old_enabled_channel3n;
    logic [31:0] old_enabled_channel4n;
    
    logic [31:0] old_unmasked_channel1n;
    logic [31:0] old_unmasked_channel2n;
    logic [31:0] old_unmasked_channel3n;
    logic [31:0] old_unmasked_channel4n;
    
    
    logic [31:0] static_mcr;
    logic [31:0] static_mcr2; 
    
    
    logic [7:0] contador;
    logic flag_wait;
    logic temp_ready;
   
   
    
    always_comb
    begin 
    						
                     
        case(state)
   
            SELECTION_MODE_AND_PARTITIONS:
            begin
                //                                $display("[SELECTION_MODE_AND_PARTITIONS]");
           			
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(rb_in_mcr[25] == 1 && rb_in_mcr[17:16] == 0) begin // 8 Partitions Mode 1 XMCME <= rb_in_mcr[25]; XMCM <= rb_in_mcr[17:16];
                        if (request_request == 1) begin
                            next <= PARTITIONS_8_MODE_0;
                        end
                        else begin
                            next <= PARTITIONS_8_MODE_0_WAIT;
                        end
                    end
	                    
                    else if(rb_in_mcr[25] == 1 && rb_in_mcr[17:16] == 1) begin // 8 Partitions Mode 1 XMCME <= rb_in_mcr[25]; XMCM <= rb_in_mcr[17:16];
                        if (request_request == 1) begin
                            next <= PARTITIONS_8_MODE_1;
                        end
                        else begin
                            next <= PARTITIONS_8_MODE_1_WAIT;
                        end
                    end
			
                    else if(rb_in_mcr[25] == 1 && rb_in_mcr[17:16] == 2) begin // 8 Partitions Mode 2 XMCME <= rb_in_mcr[25]; XMCM <= rb_in_mcr[17:16];
                        if (request_request == 1) begin
                            next <= PARTITIONS_8_MODE_2;
                        end
                        else begin
                            next <= PARTITIONS_8_MODE_2_WAIT;
                        end
                    end
			
                    else if(rb_in_mcr[25] == 1 && rb_in_mcr[17:16] == 3 && rb_in_mcr[9] == 1) begin // 8 Partitions Mode 3 XMCME <= rb_in_mcr[25]; XMCM <= rb_in_mcr[17:16]; RMCME <= rb_in_mcr[9];
                        if (request_request == 1) begin
                            next <= PARTITIONS_8_MODE_3;
                        end
                        else begin
                            next <= PARTITIONS_8_MODE_3_WAIT;
                        end
                    end
                    
                    else if(rb_in_mcr[25] == 0 && rb_in_mcr[17:16] == 0) begin // 2 Partitions Mode 0 XMCME <= rb_in_mcr[25]; XMCM <= rb_in_mcr[17:16];
                        if (request_request == 1) begin
                            next <= PARTITIONS_2_MODE_0;
                        end
                        else begin
                            next <= PARTITIONS_2_MODE_0_WAIT;
                        end
                    end

                    else if(rb_in_mcr[25] == 0 && rb_in_mcr[17:16] == 1) begin
                        if(request_request == 1) begin
                            next <= PARTITIONS_2_MODE_1;
                        end
                        else begin
                            next <= PARTITIONS_2_MODE_1_WAIT;
                        end
                    end
                    
                    else if(rb_in_mcr[25] == 0 && rb_in_mcr[17:16] == 2) begin
                        if(request_request == 1) begin
                            next <= PARTITIONS_2_MODE_2;
                        end
                        else begin
                            next <= PARTITIONS_2_MODE_2_WAIT;
                        end
                    end
                    
                    else if(rb_in_mcr[25] == 0 && rb_in_mcr[17:16] == 3 && rb_in_mcr[9] == 0) begin
                        if(request_request == 1) begin
                            next <= PARTITIONS_2_MODE_3;
                        end
                        else begin
                            next <= PARTITIONS_2_MODE_3_WAIT;
                        end
                    end
                    
                    
                end
            end
            
            
            //            ----------------------------------------------------------------
            //            						NORMAL	MODE  0
            //            ----------------------------------------------------------------
            
            PARTITIONS_2_MODE_0:
            begin
          
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request) begin
                        next <= PARTITIONS_2_MODE_0;
                    end
                    else begin
                        next <= PARTITIONS_2_MODE_0_WAIT;
                    end
                end
            end


                
            PARTITIONS_2_MODE_0_WAIT:
            begin
           
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request) begin
                        next <= PARTITIONS_2_MODE_0;
                    end
                    else begin
                        next <= PARTITIONS_2_MODE_0_WAIT;
                    end
                end
            end
            
            //            ----------------------------------------------------------------
            //            						NORMAL	MODE  1
            //            ----------------------------------------------------------------
                
                
            PARTITIONS_2_MODE_1:
            begin
                if(ac_transmit_mult_active == 0)
                begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request == 1) begin 
                        
                        next <= PARTITIONS_2_MODE_1;
                    end
                    else begin
                        next <= PARTITIONS_2_MODE_1_WAIT;
                    end
                   
                end
            end 
                

            PARTITIONS_2_MODE_1_WAIT:
            begin
                if(ac_transmit_mult_active == 0)
                begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request == 1) begin 
                        
                        next <= PARTITIONS_2_MODE_1;
                    end
                    else begin
                        next <= PARTITIONS_2_MODE_1_WAIT;
                    end
                    
                end
            end


            PARTITIONS_2_MODE_2:
            begin
                if(ac_transmit_mult_active == 0)
                begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request == 1) begin 
                        
                        next <= PARTITIONS_2_MODE_2;
                    end
                    else begin
                        next <= PARTITIONS_2_MODE_2_WAIT;
                    end
                   
                end
            end 
                

            PARTITIONS_2_MODE_2_WAIT:
            begin
                if(ac_transmit_mult_active == 0)
                begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request == 1) begin 
                        
                        next <= PARTITIONS_2_MODE_2;
                    end
                    else begin
                        next <= PARTITIONS_2_MODE_2_WAIT;
                    end
                    
                end
            end
                            
 
      
            PARTITIONS_2_MODE_3:
            begin
                if(ac_transmit_mult_active == 0)
                begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request == 1) begin
                        next <= PARTITIONS_2_MODE_3;
                    end
                    else begin
                        next <= PARTITIONS_2_MODE_3_WAIT;
                    end
                end
            end
            PARTITIONS_2_MODE_3_WAIT:
            begin
                if(ac_transmit_mult_active == 0)
                begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request == 1) begin
                        next <= PARTITIONS_2_MODE_3;
                    end
                    else begin
                        next <= PARTITIONS_2_MODE_3_WAIT;
                    end
                end
            end
            

                
                
            PARTITIONS_8_MODE_0:
            begin
                //                $display("[PARTITIONS_8_MODE_0]");
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request) begin
                        next <= PARTITIONS_8_MODE_0;
                    end
                    else begin
                        next <= PARTITIONS_8_MODE_0_WAIT;
                    end
                end
            end


                
            PARTITIONS_8_MODE_0_WAIT:
            begin
                //                $display("[PARTITIONS_8_MODE_0_WAIT]");
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request) begin
                        next <= PARTITIONS_8_MODE_0;
                    end
                    else begin
                        next <= PARTITIONS_8_MODE_0_WAIT;
                    end
                end
            end
                

            //            ----------------------------------------------------------------
            //            						ENHANCED	MODE  1
            //            ----------------------------------------------------------------
            
            PARTITIONS_8_MODE_1:
            begin
                //                $display("[PARTITIONS_8_MODE_1]");
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request) begin
                        next <= PARTITIONS_8_MODE_1;
                    end
                    else begin
                        next <= PARTITIONS_8_MODE_1_WAIT;
                    end
                end
            end

                
            PARTITIONS_8_MODE_1_WAIT:
            begin
                //                	$display("[PARTITIONS_8_MODE_1_WAIT]");
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request) begin
                        next <= PARTITIONS_8_MODE_1;
                    end
                    else begin
                        next <= PARTITIONS_8_MODE_1_WAIT;
                    end
                end
            end
			
            //            ----------------------------------------------------------------
            //            						ENHANCED	MODE  2
            //            ----------------------------------------------------------------
              
            PARTITIONS_8_MODE_2:
            begin
                //                	$display("[PARTITIONS_8_MODE_2]");
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request) begin
                        next <= PARTITIONS_8_MODE_2;
                    end
                    else begin
                        next <= PARTITIONS_8_MODE_2_WAIT;
                    end
                end
            end

                
            PARTITIONS_8_MODE_2_WAIT:
            begin
                //                	$display("[PARTITIONS_8_MODE_2_WAIT]");
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request) begin
                        next <= PARTITIONS_8_MODE_2;
                    end
                    else begin
                        next <= PARTITIONS_8_MODE_2_WAIT;
                    end
                end
            end
  
            //            ----------------------------------------------------------------
            //            						ENHANCED	MODE  3
            //            ----------------------------------------------------------------
           
            PARTITIONS_8_MODE_3:
            begin
                //                	$display("[PARTITIONS_8_MODE_3]");
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request) begin
                        next <= PARTITIONS_8_MODE_3;
                    end
                    else begin
                        next <= PARTITIONS_8_MODE_3_WAIT;
                    end
                end
            end
                             
                
            PARTITIONS_8_MODE_3_WAIT:
            begin
                //                	$display("[PARTITIONS_8_MODE_3_WAIT]");
                if(!ac_transmit_mult_active) begin
                    next <= SELECTION_MODE_AND_PARTITIONS;
                end
                else begin
                    if(request_request) begin
                        next <= PARTITIONS_8_MODE_3;
                    end
                    else begin
                        next <= PARTITIONS_8_MODE_3_WAIT;
                    end
                end
            end

            default:
            begin
                next <= SELECTION_MODE_AND_PARTITIONS;
            end
        endcase

    end
    
    always_ff @(posedge clk, posedge reset) 
    begin

        if(reset == 0) begin
     
            state <= SELECTION_MODE_AND_PARTITIONS;
        end
        else begin
        	
            state <= next;
            //estados <= next;
            case(state)
                
                SELECTION_MODE_AND_PARTITIONS:
                begin
                    contador = 0;
                    mult_out_ready <= 0;
                    mult_out_unmasked_channel1[31:0] <= 0;
                    mult_out_unmasked_channel2[31:0] <= 0;
                    mult_out_unmasked_channel3[31:0] <= 0;
                    mult_out_unmasked_channel4[31:0] <= 0;
                    mult_out_enabled_channel1[31:0] <= 0;
                    mult_out_enabled_channel2[31:0] <= 0;
                    mult_out_enabled_channel3[31:0] <= 0;
                    mult_out_enabled_channel4[31:0] <= 0;
                
                    out_ready = 1;
                    temp_ready = 1;
                   
                    
                    static_xcer0[31:0] = rb_in_xcer0[31:0];
                    static_xcer1[31:0] = rb_in_xcer1[31:0];
                    static_xcer2[31:0] = rb_in_xcer2[31:0];
                    static_xcer3[31:0] = rb_in_xcer3[31:0];
				    
                    static_rcer0[31:0] = rb_in_rcer0[31:0];
                    static_rcer1[31:0] = rb_in_rcer1[31:0];
                    static_rcer2[31:0] = rb_in_rcer2[31:0];
                    static_rcer3[31:0] = rb_in_rcer3[31:0];
				    
           
                    out_enabled_channel1[31:0] = rb_in_xcer0[31:0];
                    out_enabled_channel2[31:0] = rb_in_xcer1[31:0];
                    out_enabled_channel3[31:0] = rb_in_xcer2[31:0];
                    out_enabled_channel4[31:0] = rb_in_xcer3[31:0];
                    
                    out_unmasked_channel1[31:0] = rb_in_xcer0[31:0];
                    out_unmasked_channel2[31:0] = rb_in_xcer1[31:0];
                    out_unmasked_channel3[31:0] = rb_in_xcer2[31:0];
                    out_unmasked_channel4[31:0] = rb_in_xcer3[31:0];
                    
                    out_enabled_r_channel1 = rb_in_rcer0[31:0];
                    out_enabled_r_channel2 = rb_in_rcer1[31:0];
                    out_enabled_r_channel3 = rb_in_rcer2[31:0];
                    out_enabled_r_channel4 = rb_in_rcer3[31:0];
                    
                    out_unmasked_channel1n = rb_in_xcer0[31:0];
                    out_unmasked_channel2n = rb_in_xcer0[31:0];
                    out_unmasked_channel3n = rb_in_xcer0[31:0];
                    out_unmasked_channel4n = rb_in_xcer0[31:0];
				    
                    out_enabled_channel1n = rb_in_xcer0[31:0];
                    out_enabled_channel2n = rb_in_xcer0[31:0];
                    out_enabled_channel3n = rb_in_xcer0[31:0];
                    out_enabled_channel4n = rb_in_xcer0[31:0];
				    
                    old_enabled_channel1n = 0;
                    old_enabled_channel2n = 0;
                    old_enabled_channel3n = 0;
                    old_enabled_channel4n = 0;
                    
                    old_unmasked_channel1n = 0;
                    old_unmasked_channel2n = 0;
                    old_unmasked_channel3n = 0;
                    old_unmasked_channel4n = 0;
				    
                    flag_wait = 0;
               end
                

                PARTITIONS_2_MODE_0:
                begin
         
                    mult_out_ready <= 1;
                    mult_out_enabled_channel1[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel2[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel3[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel4[31:0] <= 32'hFFFFFFFF;
                
                    mult_out_unmasked_channel1[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel2[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel3[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel4[31:0] <= 32'hFFFFFFFF;
                
                    out_ready <= 1;
                    out_enabled_channel1[31:0] <= 32'hFFFFFFFF;
                    out_enabled_channel2[31:0] <= 32'hFFFFFFFF;
                    out_enabled_channel3[31:0] <= 32'hFFFFFFFF;
                    out_enabled_channel4[31:0] <= 32'hFFFFFFFF;
                    out_unmasked_channel1[31:0] <= 32'hFFFFFFFF;
                    out_unmasked_channel2[31:0] <= 32'hFFFFFFFF;
                    out_unmasked_channel3[31:0] <= 32'hFFFFFFFF;
                    out_unmasked_channel4[31:0] <= 32'hFFFFFFFF;
                
                end
                
                PARTITIONS_2_MODE_0_WAIT:
                begin
                    mult_out_ready <= out_ready;
                    mult_out_enabled_channel1[31:0] <= 32'hFFFFFFFF;//out_enabled_channel1[31:0];
                    mult_out_enabled_channel2[31:0] <= 32'hFFFFFFFF;//out_enabled_channel2[31:0];
                    mult_out_enabled_channel3[31:0] <= 32'hFFFFFFFF;// out_enabled_channel3[31:0];
                    mult_out_enabled_channel4[31:0] <= 32'hFFFFFFFF;// out_enabled_channel4[31:0];
                    mult_out_unmasked_channel1[31:0] <= 32'hFFFFFFFF;//out_unmasked_channel1[31:0];
                    mult_out_unmasked_channel2[31:0] <= 32'hFFFFFFFF;//out_unmasked_channel2[31:0];
                    mult_out_unmasked_channel3[31:0] <= 32'hFFFFFFFF;//out_unmasked_channel3[31:0];
                    mult_out_unmasked_channel4[31:0] <= 32'hFFFFFFFF;//out_unmasked_channel4[31:0];
                    
                end

                PARTITIONS_2_MODE_1:
                begin
                    flag_wait <= 1;
                    mult_out_ready <= 1;
                    mult_out_unmasked_channel1[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel2[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel3[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel4[31:0] <= 32'hFFFFFFFF;
                            
                    if(dynamic_rb_in_mcr[20:18]%2 == 1) begin 
                        case(dynamic_rb_in_mcr[22:21]) // XPABLK
                            0: old_enabled_channel1n[15:0] = dynamic_rb_in_xcer0[15:0]; 
                            1: old_enabled_channel2n[15:0] = dynamic_rb_in_xcer0[15:0]; 
                            2: old_enabled_channel3n[15:0] = dynamic_rb_in_xcer0[15:0];
                            3: old_enabled_channel4n[15:0] = dynamic_rb_in_xcer0[15:0];
                        endcase 
                    end
                    else begin
                        case(dynamic_rb_in_mcr[24:23]) // XPBBLK
                            0: old_enabled_channel1n[31:16] = dynamic_rb_in_xcer0[31:16]; 
                            1: old_enabled_channel2n[31:16] = dynamic_rb_in_xcer0[31:16];
                            2: old_enabled_channel3n[31:16] = dynamic_rb_in_xcer0[31:16]; 
                            3: old_enabled_channel4n[31:16] = dynamic_rb_in_xcer0[31:16];
                        endcase

                    end
                    
//                    out_enabled_channel1n[31:0] = old_enabled_channel1n[31:0];
//                    out_enabled_channel2n[31:0] = old_enabled_channel2n[31:0];
//                    out_enabled_channel3n[31:0] = old_enabled_channel3n[31:0];
//                    out_enabled_channel4n[31:0] = old_enabled_channel4n[31:0];
                    
                    mult_out_enabled_channel1[31:0] <= old_enabled_channel1n[31:0];
                    mult_out_enabled_channel2[31:0] <= old_enabled_channel2n[31:0];
                    mult_out_enabled_channel3[31:0] <= old_enabled_channel3n[31:0];
                    mult_out_enabled_channel4[31:0] <= old_enabled_channel4n[31:0];
                        
                end
                       
                PARTITIONS_2_MODE_1_WAIT:
                begin
                    mult_out_ready <= out_ready;
                    if(flag_wait) begin
                        mult_out_unmasked_channel1[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel2[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel3[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel4[31:0] <= 32'hFFFFFFFF;
                        
                        mult_out_enabled_channel1[31:0] <= old_enabled_channel1n[31:0];
                        mult_out_enabled_channel2[31:0] <= old_enabled_channel2n[31:0];
                        mult_out_enabled_channel3[31:0] <= old_enabled_channel3n[31:0];
                        mult_out_enabled_channel4[31:0] <= old_enabled_channel4n[31:0];
                    end
                    else begin
                        mult_out_unmasked_channel1[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel2[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel3[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel4[31:0] <= 32'hFFFFFFFF;
                            
                        mult_out_enabled_channel1[31:0] <= 0;
                        mult_out_enabled_channel2[31:0] <= 0;
                        mult_out_enabled_channel3[31:0] <= 0;
                        mult_out_enabled_channel4[31:0] <= 0;
                        
                    end
                end
      
                PARTITIONS_2_MODE_2:
                begin
                    flag_wait <= 1;
                    mult_out_ready <= 1;
                            
                    mult_out_enabled_channel1[31:0] <= 32'hFFFFFFFF; // TA ERRADO AQUI ! 
                    mult_out_enabled_channel2[31:0] <= 32'hFFFFFFFF; // NAO DEVIA TA ZERANDO TUDO TODA VEZ!
                    mult_out_enabled_channel3[31:0] <= 32'hFFFFFFFF; // QND TIVER FAZENDO O PING PONG, ELE VAI
                    mult_out_enabled_channel4[31:0] <= 32'hFFFFFFFF; // ESQUECER O Q TAVA NA SAIDA ANTES DE TROCAR
                    
                    if(dynamic_rb_in_mcr[20:18]%2 == 1) begin 
                        case(dynamic_rb_in_mcr[22:21]) // XPABLK
                            0: old_unmasked_channel1n[15:0] = dynamic_rb_in_xcer0[15:0];
                            1: old_unmasked_channel2n[15:0] = dynamic_rb_in_xcer0[15:0];
                            2: old_unmasked_channel3n[15:0] = dynamic_rb_in_xcer0[15:0];
                            3: old_unmasked_channel4n[15:0] = dynamic_rb_in_xcer0[15:0];
                        endcase
                    end 
                    else begin
                        case(dynamic_rb_in_mcr[24:23]) // XPBBLK
                            0: old_unmasked_channel1n[31:16] = dynamic_rb_in_xcer0[31:16];
                            1: old_unmasked_channel2n[31:16] = dynamic_rb_in_xcer0[31:16];
                            2: old_unmasked_channel3n[31:16] = dynamic_rb_in_xcer0[31:16];
                            3: old_unmasked_channel4n[31:16] = dynamic_rb_in_xcer0[31:16];
                        endcase
                    end

                    out_unmasked_channel1n[31:0] <= old_unmasked_channel1n[31:0];
                    out_unmasked_channel2n[31:0] <= old_unmasked_channel2n[31:0];
                    out_unmasked_channel3n[31:0] <= old_unmasked_channel3n[31:0];
                    out_unmasked_channel4n[31:0] <= old_unmasked_channel4n[31:0];
                    
                    mult_out_unmasked_channel1[31:0] <= old_unmasked_channel1n[31:0];
                    mult_out_unmasked_channel2[31:0] <= old_unmasked_channel2n[31:0];
                    mult_out_unmasked_channel3[31:0] <= old_unmasked_channel3n[31:0];
                    mult_out_unmasked_channel4[31:0] <= old_unmasked_channel4n[31:0];
                        
                end
                       
                PARTITIONS_2_MODE_2_WAIT:
                begin

                    mult_out_ready <= out_ready;
                    if(flag_wait) begin
                        mult_out_enabled_channel1[31:0] <= 32'hFFFFFFFF;
                        mult_out_enabled_channel2[31:0] <= 32'hFFFFFFFF;
                        mult_out_enabled_channel3[31:0] <= 32'hFFFFFFFF;
                        mult_out_enabled_channel4[31:0] <= 32'hFFFFFFFF;
                        
                        mult_out_unmasked_channel1[31:0] <= out_unmasked_channel1n[31:0];
                        mult_out_unmasked_channel2[31:0] <= out_unmasked_channel2n[31:0];
                        mult_out_unmasked_channel3[31:0] <= out_unmasked_channel3n[31:0];
                        mult_out_unmasked_channel4[31:0] <= out_unmasked_channel4n[31:0];
                    end
                    else begin
                        mult_out_unmasked_channel1[31:0] <= 0;
                        mult_out_unmasked_channel2[31:0] <= 0;
                        mult_out_unmasked_channel3[31:0] <= 0;
                        mult_out_unmasked_channel4[31:0] <= 0;
                            
                        mult_out_enabled_channel1[31:0] <= 32'hFFFFFFFF;
                        mult_out_enabled_channel2[31:0] <= 32'hFFFFFFFF;
                        mult_out_enabled_channel3[31:0] <= 32'hFFFFFFFF;
                        mult_out_enabled_channel4[31:0] <= 32'hFFFFFFFF;
                        
                        //                        case(static_mcr2[22:21]) // XPABLK
                        //                            0:
                        //                            begin
                        //                                mult_out_unmasked_channel1[15:0] <= out_enabled_channel1n[15:0];
                        //                            end
                        //                            1:
                        //                            begin 
                        //                                mult_out_unmasked_channel2[15:0] <= out_enabled_channel1n[15:0];
                        //                            end
                        //                            2:
                        //                            begin
                        //                                mult_out_unmasked_channel3[15:0] <= out_enabled_channel1n[15:0];
                        //                            end
                        //                            default:
                        //                            begin
                        //                                mult_out_unmasked_channel4[15:0] <= out_enabled_channel1n[15:0];
                        //                            end
                        //                        endcase 
                        //  
                        //                        case(static_mcr2[24:23]) // XPBBLK
                        //                            0:
                        //                            begin
                        //                                mult_out_unmasked_channel1[31:16] <= out_enabled_channel1n[31:16];
                        //                            end
                        //                            1:
                        //                            begin 
                        //                                mult_out_unmasked_channel2[31:16] <= out_enabled_channel1n[31:16];
                        //                            end
                        //                            2:
                        //                            begin
                        //                                mult_out_unmasked_channel3[31:16] <= out_enabled_channel1n[31:16];
                        //                            end
                        //                            default:
                        //                            begin
                        //                                mult_out_unmasked_channel4[31:16] <= out_enabled_channel1n[31:16];
                        //                            end
                        //                        endcase
                    end
                end
                
                PARTITIONS_2_MODE_3:
                begin

                    if(dynamic_rb_in_mcr[4:2]%2 == 1) begin //RCBLK
                    	$display("Entrei no pablk %d",contador);
                        case(dynamic_rb_in_mcr[6:5]) // RPABLK
                            0: begin
                            	old_enabled_channel1n[15:0] = dynamic_rb_in_rcer0[15:0];
                            	old_unmasked_channel1n[15:0] = dynamic_rb_in_xcer0[15:0];
                            end
                            1: begin
                            	old_enabled_channel2n[15:0] = dynamic_rb_in_rcer0[15:0];
                            	old_unmasked_channel2n[15:0] = dynamic_rb_in_xcer0[15:0];
                            end
                            2: begin
                            	old_enabled_channel3n[15:0] = dynamic_rb_in_rcer0[15:0];
                            	old_unmasked_channel3n[15:0] = dynamic_rb_in_xcer0[15:0];
                            end
                            3: begin
                            	old_enabled_channel4n[15:0] = dynamic_rb_in_rcer0[15:0];
                            	old_unmasked_channel4n[15:0] = dynamic_rb_in_xcer0[15:0];
                            end
                        endcase                        
                    end 
                    else begin
                    	$display("Entrei no pbblk %d",contador);
                        case(dynamic_rb_in_mcr[8:7]) // RPBBLK
                            0: begin
                            	old_enabled_channel1n[31:16] = dynamic_rb_in_rcer0[31:16];
                            	old_unmasked_channel1n[31:16] = dynamic_rb_in_xcer0[31:16];
                            end
                            1: begin
                            	old_enabled_channel2n[31:16] = dynamic_rb_in_rcer0[31:16];
                            	old_unmasked_channel2n[31:16] = dynamic_rb_in_xcer0[31:16];
                            end
                            2: begin
                            	old_enabled_channel3n[31:16] = dynamic_rb_in_rcer0[31:16];
                            	old_unmasked_channel3n[31:16] = dynamic_rb_in_xcer0[31:16];
                            end
                            3: begin
                            	old_enabled_channel4n[31:16] = dynamic_rb_in_rcer0[31:16];
                            	old_unmasked_channel4n[31:16] = dynamic_rb_in_xcer0[31:16];
                            end
                        endcase
                        
                    end

                    flag_wait <= 1;
                    mult_out_ready <= 1;

                    mult_out_enabled_channel1[31:0] <= old_enabled_channel1n[31:0];
                    mult_out_enabled_channel2[31:0] <= old_enabled_channel2n[31:0];
                    mult_out_enabled_channel3[31:0] <= old_enabled_channel3n[31:0];
                    mult_out_enabled_channel4[31:0] <= old_enabled_channel4n[31:0];
                    
                    mult_out_unmasked_channel1[31:0] <= old_unmasked_channel1n[31:0];
                    mult_out_unmasked_channel2[31:0] <= old_unmasked_channel2n[31:0];
                    mult_out_unmasked_channel3[31:0] <= old_unmasked_channel3n[31:0];
                    mult_out_unmasked_channel4[31:0] <= old_unmasked_channel4n[31:0];
                        
                end
                       
                PARTITIONS_2_MODE_3_WAIT:
                begin
                    temp_ready <= out_ready;
                    mult_out_ready <= temp_ready;
                    if(flag_wait) begin
                        mult_out_enabled_channel1[31:0] <= old_enabled_channel1n[31:0];
                        mult_out_enabled_channel2[31:0] <= old_enabled_channel2n[31:0];
                        mult_out_enabled_channel3[31:0] <= old_enabled_channel3n[31:0];
                        mult_out_enabled_channel4[31:0] <= old_enabled_channel4n[31:0];
                        
                        mult_out_unmasked_channel1[31:0] <= old_enabled_channel1n[31:0];
                        mult_out_unmasked_channel2[31:0] <= old_enabled_channel2n[31:0];
                        mult_out_unmasked_channel3[31:0] <= old_enabled_channel3n[31:0];
                        mult_out_unmasked_channel4[31:0] <= old_enabled_channel4n[31:0];
                    end
                    else begin 
                        mult_out_enabled_channel1[31:0] <= 0;
                        mult_out_enabled_channel2[31:0] <= 0;
                        mult_out_enabled_channel3[31:0] <= 0;
                        mult_out_enabled_channel4[31:0] <= 0;

                        mult_out_unmasked_channel1[31:0] <= 0;
                        mult_out_unmasked_channel2[31:0] <= 0;
                        mult_out_unmasked_channel3[31:0] <= 0;
                        mult_out_unmasked_channel4[31:0] <= 0;
                    end
                end
    			
                
                //            
                //            ----------------------------------------------------------------
                //            						ENHANCED	MODE 0
                //            ----------------------------------------------------------------
            
                PARTITIONS_8_MODE_0:
                begin
         
                    mult_out_ready <= 1;
                    
                    mult_out_enabled_channel1[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel2[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel3[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel4[31:0] <= 32'hFFFFFFFF;
                
                    mult_out_unmasked_channel1[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel2[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel3[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel4[31:0] <= 32'hFFFFFFFF;
                
                
                end
                
                PARTITIONS_8_MODE_0_WAIT:
                begin
                	
                    mult_out_ready <= 1;
                    
                    mult_out_enabled_channel1[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel2[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel3[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel4[31:0] <= 32'hFFFFFFFF;
                    
                    mult_out_unmasked_channel1[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel2[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel3[31:0] <= 32'hFFFFFFFF;
                    mult_out_unmasked_channel4[31:0] <= 32'hFFFFFFFF;
                    
                end
                
	        
                PARTITIONS_8_MODE_1:
                begin
                	               	
                    mult_out_unmasked_channel1 = 32'hFFFFFFFF;
                    mult_out_unmasked_channel2 = 32'hFFFFFFFF;
                    mult_out_unmasked_channel3 = 32'hFFFFFFFF;
                    mult_out_unmasked_channel4 = 32'hFFFFFFFF;
                    
                    case (dynamic_rb_in_mcr[20:18])// XCBLK
                        0: begin 
                            mult_out_enabled_channel1[15:0] = out_enabled_channel1[15:0];
                            mult_out_enabled_channel1[31:16] = dynamic_rb_in_xcer0[31:16]; 
                            mult_out_enabled_channel2 = dynamic_rb_in_xcer1;
                            mult_out_enabled_channel3 = dynamic_rb_in_xcer2;
                            mult_out_enabled_channel4 = dynamic_rb_in_xcer3;
                            
            
                        end
                        1: begin
                            mult_out_enabled_channel1[15:0] = dynamic_rb_in_xcer0[15:0]; 
                            mult_out_enabled_channel1[31:16] = out_enabled_channel1[31:16];
                            mult_out_enabled_channel2 = dynamic_rb_in_xcer1;
                            mult_out_enabled_channel3 = dynamic_rb_in_xcer2;
                            mult_out_enabled_channel4 = dynamic_rb_in_xcer3;
                            

                        end
                        2: begin
                            mult_out_enabled_channel1 = dynamic_rb_in_xcer0;
                            mult_out_enabled_channel2[15:0] = out_enabled_channel2[15:0];
                            mult_out_enabled_channel2[31:16] = dynamic_rb_in_xcer1[31:16]; 
                            mult_out_enabled_channel3 = dynamic_rb_in_xcer2;
                            mult_out_enabled_channel4 = dynamic_rb_in_xcer3;
                            

                        end
                        3: begin
                            mult_out_enabled_channel1 = dynamic_rb_in_xcer0;
                            mult_out_enabled_channel2[15:0] = dynamic_rb_in_xcer1[15:0]; 
                            mult_out_enabled_channel2[31:16] = out_enabled_channel2[31:16];
                            mult_out_enabled_channel3 = dynamic_rb_in_xcer2;
                            mult_out_enabled_channel4 = dynamic_rb_in_xcer3;
                            
   
                        end
                        4: begin
                            mult_out_enabled_channel1 = dynamic_rb_in_xcer0;
                            mult_out_enabled_channel2 = dynamic_rb_in_xcer1;
                            mult_out_enabled_channel3[15:0] = out_enabled_channel3[15:0];
                            mult_out_enabled_channel3[31:16] = dynamic_rb_in_xcer2[31:16]; 
                            mult_out_enabled_channel4 = dynamic_rb_in_xcer3;
                            
        
                        end
                        5: begin
                            mult_out_enabled_channel1 = dynamic_rb_in_xcer0;
                            mult_out_enabled_channel2 = dynamic_rb_in_xcer1;
                            mult_out_enabled_channel3[15:0] = dynamic_rb_in_xcer2[15:0]; 
                            mult_out_enabled_channel3[31:16] = out_enabled_channel3[31:16];
                            mult_out_enabled_channel4 = dynamic_rb_in_xcer3;
                             
         
                        end
                        6: begin
                            mult_out_enabled_channel1 = dynamic_rb_in_xcer0;
                            mult_out_enabled_channel2 = dynamic_rb_in_xcer1;
                            mult_out_enabled_channel3 = dynamic_rb_in_xcer2;
                            mult_out_enabled_channel4[15:0] = out_enabled_channel4[15:0];
                            mult_out_enabled_channel4[31:16] = dynamic_rb_in_xcer3[31:16]; 
 
                        end
                        default: begin
                            mult_out_enabled_channel1 = dynamic_rb_in_xcer0;
                            mult_out_enabled_channel2 = dynamic_rb_in_xcer1;
                            mult_out_enabled_channel3 = dynamic_rb_in_xcer2;
                            mult_out_enabled_channel4[15:0] = dynamic_rb_in_xcer3[15:0];
                            mult_out_enabled_channel4[31:16] = out_enabled_channel4[31:16]; // update the A portion of rcere3
                            

                        end 
                    endcase 
                    mult_out_ready <= 1;

                    flag_wait = 1; 
                    out_ready = 1;
                    
                    out_enabled_channel1[31:0] = mult_out_enabled_channel1[31:0];
                    out_enabled_channel2[31:0] = mult_out_enabled_channel2[31:0];
                    out_enabled_channel3[31:0] = mult_out_enabled_channel3[31:0];
                    out_enabled_channel4[31:0] = mult_out_enabled_channel4[31:0];
                    
                   
                end
                
                PARTITIONS_8_MODE_1_WAIT:
                begin
                    
         
                    mult_out_ready <= out_ready ;
                    
                    if(flag_wait == 1) begin
                      
                    	
                        mult_out_enabled_channel1[31:0] <= out_enabled_channel1[31:0];
                        mult_out_enabled_channel2[31:0] <= out_enabled_channel2[31:0];
                        mult_out_enabled_channel3[31:0] <= out_enabled_channel3[31:0];
                        mult_out_enabled_channel4[31:0] <= out_enabled_channel4[31:0];
                        mult_out_unmasked_channel1[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel2[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel3[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel4[31:0] <= 32'hFFFFFFFF;
                    end
                    
                    else begin
                    	
                        mult_out_enabled_channel1[31:0] <= static_xcer0[31:0];
                        mult_out_enabled_channel2[31:0] <= static_xcer1[31:0];
                        mult_out_enabled_channel3[31:0] <= static_xcer2[31:0];
                        mult_out_enabled_channel4[31:0] <= static_xcer3[31:0];
                        mult_out_unmasked_channel1[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel2[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel3[31:0] <= 32'hFFFFFFFF;
                        mult_out_unmasked_channel4[31:0] <= 32'hFFFFFFFF;
                    end

                end
                //            ----------------------------------------------------------------
                //            						ENHANCED	MODE 2
                //            ----------------------------------------------------------------
                PARTITIONS_8_MODE_2:
                begin
                	
                	               	
                    mult_out_ready <= 1;
               
                                           
                    mult_out_enabled_channel1[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel2[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel3[31:0] <= 32'hFFFFFFFF;
                    mult_out_enabled_channel4[31:0] <= 32'hFFFFFFFF;
                                   

                    case (dynamic_rb_in_mcr[20:18])// XCBLK
                        0: begin 
                            mult_out_unmasked_channel1[15:0] = out_unmasked_channel1[15:0];
                            mult_out_unmasked_channel1[31:16] = dynamic_rb_in_xcer0[31:16]; 
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;
                        end
                        1: begin
                            mult_out_unmasked_channel1[15:0] = dynamic_rb_in_xcer0[15:0]; 
                            mult_out_unmasked_channel1[31:16] = out_unmasked_channel1[31:16];
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;
                        end
                        2: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2[15:0] = out_unmasked_channel2[15:0];
                            mult_out_unmasked_channel2[31:16] = dynamic_rb_in_xcer1[31:16]; 
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;
                        end
                        3: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2[15:0] = dynamic_rb_in_xcer1[15:0]; 
                            mult_out_unmasked_channel2[31:16] = out_unmasked_channel2[31:16];
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;
                        end
                        4: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3[15:0] = out_unmasked_channel3[15:0];
                            mult_out_unmasked_channel3[31:16] = dynamic_rb_in_xcer2[31:16]; 
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;
                        end
                        5: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3[15:0] = dynamic_rb_in_xcer2[15:0]; 
                            mult_out_unmasked_channel3[31:16] = out_unmasked_channel3[31:16];
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;
                        end
                        6: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4[15:0] = out_unmasked_channel4[15:0];
                            mult_out_unmasked_channel4[31:16] = dynamic_rb_in_xcer3[31:16]; 
                        end
                        7: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4[15:0] = dynamic_rb_in_xcer3[15:0];
                            mult_out_unmasked_channel4[31:16] = out_unmasked_channel4[31:16]; // update the A portion of rcere3
                        end 
                    endcase 

                    flag_wait <= 1; 
                    out_ready <= 1;
                    out_unmasked_channel1[31:0] = mult_out_unmasked_channel1[31:0];
                    out_unmasked_channel2[31:0] = mult_out_unmasked_channel2[31:0];
                    out_unmasked_channel3[31:0] = mult_out_unmasked_channel3[31:0];
                    out_unmasked_channel4[31:0] = mult_out_unmasked_channel4[31:0]; 
                    
                    
                    out_enabled_channel1[31:0] = 32'hFFFFFFFF;
                    out_enabled_channel2[31:0] = 32'hFFFFFFFF;
                    out_enabled_channel3[31:0] = 32'hFFFFFFFF;
                    out_enabled_channel4[31:0] = 32'hFFFFFFFF;
                
                end
                
                PARTITIONS_8_MODE_2_WAIT:
                begin
                    mult_out_ready <= out_ready ;
                    
                    if(flag_wait == 1) begin
                        //                    	$display("[DUV] entrei no flag_wait enabled_channel1(%d)= %x",cont, mult_out_unmasked_channel1); 
                    	
                        mult_out_unmasked_channel1[31:0] <= out_enabled_channel1[31:0];
                        mult_out_unmasked_channel2[31:0] <= out_enabled_channel2[31:0];
                        mult_out_unmasked_channel3[31:0] <= out_enabled_channel3[31:0];
                        mult_out_unmasked_channel4[31:0] <= out_enabled_channel4[31:0];
                        mult_out_enabled_channel1[31:0] <= out_enabled_channel1[31:0];
                        mult_out_enabled_channel2[31:0] <= out_enabled_channel2[31:0];
                        mult_out_enabled_channel3[31:0] <= out_enabled_channel3[31:0];
                        mult_out_enabled_channel4[31:0] <= out_enabled_channel4[31:0];
                    end
                    
                    else begin
                        mult_out_unmasked_channel1[31:0] <= static_xcer0[31:0];
                        mult_out_unmasked_channel2[31:0] <= static_xcer1[31:0];
                        mult_out_unmasked_channel3[31:0] <= static_xcer2[31:0];
                        mult_out_unmasked_channel4[31:0] <= static_xcer3[31:0];
                        mult_out_enabled_channel1[31:0] <= 32'hFFFFFFFF;
                        mult_out_enabled_channel2[31:0] <= 32'hFFFFFFFF;
                        mult_out_enabled_channel3[31:0] <= 32'hFFFFFFFF;
                        mult_out_enabled_channel4[31:0] <= 32'hFFFFFFFF;
                    end
                end
               
		  
                //            ----------------------------------------------------------------
                //            						ENHANCED	MODE 3
                //            ----------------------------------------------------------------
                
                PARTITIONS_8_MODE_3:
                begin
                	
                	               	
                    mult_out_ready <= 1;
               

                    case (dynamic_rb_in_mcr[4:2])// RCBLK
                        0: begin 
                            mult_out_unmasked_channel1[15:0] = out_unmasked_channel1[15:0];
                            mult_out_unmasked_channel1[31:16] = dynamic_rb_in_xcer0[31:16]; 
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;

                            mult_out_enabled_channel1[15:0] = out_enabled_r_channel1[15:0];
                            mult_out_enabled_channel1[31:16] = dynamic_rb_in_rcer0[31:16]; 
                            mult_out_enabled_channel2 = dynamic_rb_in_rcer1;
                            mult_out_enabled_channel3 = dynamic_rb_in_rcer2;
                            mult_out_enabled_channel4 = dynamic_rb_in_rcer3;
                        end
                        1: begin
                            mult_out_unmasked_channel1[15:0] = dynamic_rb_in_xcer0[15:0]; 
                            mult_out_unmasked_channel1[31:16] = out_unmasked_channel1[31:16];
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;

                            mult_out_enabled_channel1[15:0] = dynamic_rb_in_rcer0[15:0];
                            mult_out_enabled_channel1[31:16] = out_enabled_r_channel1[31:16]; 
                            mult_out_enabled_channel2 = dynamic_rb_in_rcer1;
                            mult_out_enabled_channel3 = dynamic_rb_in_rcer2;
                            mult_out_enabled_channel4 = dynamic_rb_in_rcer3;
                        end
                        2: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2[15:0] = out_unmasked_channel2[15:0];
                            mult_out_unmasked_channel2[31:16] = dynamic_rb_in_xcer1[31:16]; 
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;

                            mult_out_enabled_channel1 = dynamic_rb_in_rcer0;
                            mult_out_enabled_channel2[15:0] = out_enabled_r_channel2[15:0];
                            mult_out_enabled_channel2[31:16] = dynamic_rb_in_rcer1[31:16]; 
                            mult_out_enabled_channel3 = dynamic_rb_in_rcer2;
                            mult_out_enabled_channel4 = dynamic_rb_in_rcer3;
                        end
                        3: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2[15:0] = dynamic_rb_in_xcer1[15:0]; 
                            mult_out_unmasked_channel2[31:16] = out_unmasked_channel2[31:16];
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;

                            mult_out_enabled_channel1 = dynamic_rb_in_rcer0;
                            mult_out_enabled_channel2[15:0] = dynamic_rb_in_rcer1[15:0];
                            mult_out_enabled_channel2[31:16] = out_enabled_r_channel2[31:16]; 
                            mult_out_enabled_channel3 = dynamic_rb_in_rcer2;
                            mult_out_enabled_channel4 = dynamic_rb_in_rcer3;
                        end
                        4: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3[15:0] = out_unmasked_channel3[15:0];
                            mult_out_unmasked_channel3[31:16] = dynamic_rb_in_xcer2[31:16]; 
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;

                            mult_out_enabled_channel1 = dynamic_rb_in_rcer0;
                            mult_out_enabled_channel2 = dynamic_rb_in_rcer1;
                            mult_out_enabled_channel3[15:0] = out_enabled_r_channel3[15:0];
                            mult_out_enabled_channel3[31:16] = dynamic_rb_in_rcer2[31:16]; 
                            mult_out_enabled_channel4 = dynamic_rb_in_rcer3;
                        end
                        5: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3[15:0] = dynamic_rb_in_xcer2[15:0]; 
                            mult_out_unmasked_channel3[31:16] = out_unmasked_channel3[31:16];
                            mult_out_unmasked_channel4 = dynamic_rb_in_xcer3;

                            mult_out_enabled_channel1 = dynamic_rb_in_rcer0;
                            mult_out_enabled_channel2 = dynamic_rb_in_rcer1;
                            mult_out_enabled_channel3[15:0] = dynamic_rb_in_rcer2[15:0];
                            mult_out_enabled_channel3[31:16] = out_enabled_r_channel3[31:16]; 
                            mult_out_enabled_channel4 = dynamic_rb_in_rcer3;
                        end
                        6: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4[15:0] = out_unmasked_channel4[15:0];
                            mult_out_unmasked_channel4[31:16] = dynamic_rb_in_xcer3[31:16]; 

                            mult_out_enabled_channel1 = dynamic_rb_in_rcer0;
                            mult_out_enabled_channel2 = dynamic_rb_in_rcer1;
                            mult_out_enabled_channel3 = dynamic_rb_in_rcer2;
                            mult_out_enabled_channel4[15:0] = out_enabled_r_channel4[15:0];
                            mult_out_enabled_channel4[31:16] = dynamic_rb_in_rcer3[31:16]; 
                        end
                        7: begin
                            mult_out_unmasked_channel1 = dynamic_rb_in_xcer0;
                            mult_out_unmasked_channel2 = dynamic_rb_in_xcer1;
                            mult_out_unmasked_channel3 = dynamic_rb_in_xcer2;
                            mult_out_unmasked_channel4[15:0] = dynamic_rb_in_xcer3[15:0];
                            mult_out_unmasked_channel4[31:16] = out_unmasked_channel4[31:16]; // update the A portion of rcere3

                            mult_out_enabled_channel1 = dynamic_rb_in_rcer0;
                            mult_out_enabled_channel2 = dynamic_rb_in_rcer1;
                            mult_out_enabled_channel3 = dynamic_rb_in_rcer2;
                            mult_out_enabled_channel4[15:0] = dynamic_rb_in_rcer3[15:0];
                            mult_out_enabled_channel4[31:16] = out_enabled_r_channel4[31:16]; 
                        end 
                    endcase 

                    flag_wait <= 1; 
                    out_ready <= 1;
                    out_unmasked_channel1[31:0] = mult_out_unmasked_channel1[31:0];
                    out_unmasked_channel2[31:0] = mult_out_unmasked_channel2[31:0];
                    out_unmasked_channel3[31:0] = mult_out_unmasked_channel3[31:0];
                    out_unmasked_channel4[31:0] = mult_out_unmasked_channel4[31:0]; 
                    
                    out_enabled_r_channel1[31:0] = mult_out_enabled_channel1[31:0];
                    out_enabled_r_channel2[31:0] = mult_out_enabled_channel2[31:0];
                    out_enabled_r_channel3[31:0] = mult_out_enabled_channel3[31:0];
                    out_enabled_r_channel4[31:0] = mult_out_enabled_channel4[31:0];
                    
                    
                end
                
                PARTITIONS_8_MODE_3_WAIT:
                begin
                    mult_out_ready <= out_ready ;
                    
                    if(flag_wait == 1) begin
                        //                    	$display("[DUV] entrei no flag_wait enabled_channel1(%d)= %x",cont, mult_out_unmasked_channel1); 
                    	
                        mult_out_unmasked_channel1[31:0] <= out_unmasked_channel1[31:0];
                        mult_out_unmasked_channel2[31:0] <= out_unmasked_channel2[31:0];
                        mult_out_unmasked_channel3[31:0] <= out_unmasked_channel3[31:0];
                        mult_out_unmasked_channel4[31:0] <= out_unmasked_channel4[31:0];
                        mult_out_enabled_channel1[31:0] <= out_enabled_channel1[31:0];
                        mult_out_enabled_channel2[31:0] <= out_enabled_channel2[31:0];
                        mult_out_enabled_channel3[31:0] <= out_enabled_channel3[31:0];
                        mult_out_enabled_channel4[31:0] <= out_enabled_channel4[31:0];
                    end
                    
                    else begin
                        mult_out_unmasked_channel1[31:0] <= static_xcer0[31:0];
                        mult_out_unmasked_channel2[31:0] <= static_xcer1[31:0];
                        mult_out_unmasked_channel3[31:0] <= static_xcer2[31:0];
                        mult_out_unmasked_channel4[31:0] <= static_xcer3[31:0];
                        mult_out_enabled_channel1[31:0] <= static_rcer0[31:0];
                        mult_out_enabled_channel2[31:0] <= static_rcer1[31:0];
                        mult_out_enabled_channel3[31:0] <= static_rcer2[31:0];
                        mult_out_enabled_channel4[31:0] <= static_rcer3[31:0];
                    end
                end

            endcase

            //			$display("---CONTADOR %d---",contador);            
                        contador++;
        end
    end
    
    initial begin
        $shm_open("waves.shm");
        $shm_probe(mult_out_unmasked_channel1,
            mult_out_unmasked_channel2,
            mult_out_unmasked_channel3,
            mult_out_unmasked_channel4,
            mult_out_enabled_channel1,
            mult_out_enabled_channel2,
            mult_out_enabled_channel3,
            mult_out_enabled_channel4, 
            mult_out_enabled_channel1,
            mult_out_enabled_channel2,
            mult_out_enabled_channel3,
            mult_out_enabled_channel4,
            mult_out_ready,
            request_request,
            ac_transmit_mult_active,
            state,
            clk
    		
        );
               
      
         
               
    end
endmodule
    
