//Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
//use of Altera Corporation's design tools, logic functions and other
//software and tools, and its AMPP partner logic functions, and any
//output files any of the foregoing (including device programming or
//simulation files), and any associated documentation or information are
//expressly subject to the terms and conditions of the Altera Program
//License Subscription Agreement or other applicable license agreement,
//including, without limitation, that your use is for the sole purpose
//of programming logic devices manufactured by Altera and sold by Altera
//or its authorized distributors.  Please refer to the applicable
//agreement for further details.

// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module top_transmit_inst (
                           // inputs:
                            clk,
                            clkr,
                            clks,
                            clkx,
                            dxr_in_address,
                            dxr_in_begin_transfer,
                            dxr_in_byte_enable,
                            dxr_in_write,
                            dxr_in_write_data,
                            fsr,
                            fsx,
                            rb_in_address,
                            rb_in_begin_transfer,
                            rb_in_byte_enable,
                            rb_in_read,
                            rb_in_write,
                            rb_in_write_data,
                            reset,

                           // outputs:
                            dlb_out_data,
                            dx_out_dx,
                            dxr_in_wait_request,
                            dxr_int_out_xevt,
                            dxr_int_out_xint,
                            pins_out_clkr,
                            pins_out_clkx,
                            pins_out_fsr,
                            pins_out_fsx,
                            rb_in_wait_request,
                            rb_read_data
                         )
;

  output           dlb_out_data;
  output           dx_out_dx;
  output           dxr_in_wait_request;
  output           dxr_int_out_xevt;
  output           dxr_int_out_xint;
  output           pins_out_clkr;
  output           pins_out_clkx;
  output           pins_out_fsr;
  output           pins_out_fsx;
  output           rb_in_wait_request;
  output  [ 31: 0] rb_read_data;
  input            clk;
  input            clkr;
  input            clks;
  input            clkx;
  input   [ 31: 0] dxr_in_address;
  input            dxr_in_begin_transfer;
  input   [  3: 0] dxr_in_byte_enable;
  input            dxr_in_write;
  input   [ 31: 0] dxr_in_write_data;
  input            fsr;
  input            fsx;
  input   [ 31: 0] rb_in_address;
  input            rb_in_begin_transfer;
  input   [  3: 0] rb_in_byte_enable;
  input            rb_in_read;
  input            rb_in_write;
  input   [ 31: 0] rb_in_write_data;
  input            reset;

  wire             dlb_out_data;
  wire             dx_out_dx;
  wire             dxr_in_wait_request;
  wire             dxr_int_out_xevt;
  wire             dxr_int_out_xint;
  wire             pins_out_clkr;
  wire             pins_out_clkx;
  wire             pins_out_fsr;
  wire             pins_out_fsx;
  wire             rb_in_wait_request;
  wire    [ 31: 0] rb_read_data;
  demo_transmit the_demo_transmit
    (
      .clk                   (clk),
      .clkr                  (clkr),
      .clks                  (clks),
      .clkx                  (clkx),
      .dlb_out_data          (dlb_out_data),
      .dx_out_dx             (dx_out_dx),
      .dxr_in_address        (dxr_in_address),
      .dxr_in_begin_transfer (dxr_in_begin_transfer),
      .dxr_in_byte_enable    (dxr_in_byte_enable),
      .dxr_in_wait_request   (dxr_in_wait_request),
      .dxr_in_write          (dxr_in_write),
      .dxr_in_write_data     (dxr_in_write_data),
      .dxr_int_out_xevt      (dxr_int_out_xevt),
      .dxr_int_out_xint      (dxr_int_out_xint),
      .fsr                   (fsr),
      .fsx                   (fsx),
      .pins_out_clkr         (pins_out_clkr),
      .pins_out_clkx         (pins_out_clkx),
      .pins_out_fsr          (pins_out_fsr),
      .pins_out_fsx          (pins_out_fsx),
      .rb_in_address         (rb_in_address),
      .rb_in_begin_transfer  (rb_in_begin_transfer),
      .rb_in_byte_enable     (rb_in_byte_enable),
      .rb_in_read            (rb_in_read),
      .rb_in_wait_request    (rb_in_wait_request),
      .rb_in_write           (rb_in_write),
      .rb_in_write_data      (rb_in_write_data),
      .rb_read_data          (rb_read_data),
      .reset                 (reset)
    );


endmodule

